#include <bits/stdc++.h>

using namespace std;

#define nl '\n'
int psum[500001][31];
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
        cin>>n>>q;

    vector<int> a(n);
    int bits[n][32];
        for(int i =0;i<n;i++){
            cin>>a[i];
        }

        for(int i =0;i<n;i++){

            for(int j =0;j<31;j++){
                int k = 1<<j;
                if(!(a[i]&k))bits[i][j]=0;
                else bits[i][j]=1;
            }


        }


        for(int i =1;i<=n;i++){
            for(int j = 0;j<31;j++){
                psum[i][j]=psum[i-1][j]+bits[i-1][j];
            }
        }




        for(int i =0;i<q;i++){
            int l,r;
            cin>>l>>r;
            int p = 30;
            int s = 0;
            while(s==0 && p>-1){
                s = psum[r][p]-psum[l-1][p];
                p--;
            }
            cout<<s<<nl;
        }

    return 0;
}